<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fwFSMConfDB: fwFsmConfDB.ctl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fwFSMConfDB
   &#160;<span id="projectnumber">8.4.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('fwFsmConfDB_8ctl.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">fwFsmConfDB.ctl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:aec2ab037a47918414e6efd114b2ad62b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#aec2ab037a47918414e6efd114b2ad62b">fwFSMConfDB_initialize</a> (string sDomain, string sConfigurator)</td></tr>
<tr class="separator:aec2ab037a47918414e6efd114b2ad62b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a425183ca3f4ae7ca52633c69ca416a50"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a425183ca3f4ae7ca52633c69ca416a50">fwFSMConfDB_getUseConfDB</a> (string sConfigurator)</td></tr>
<tr class="separator:a425183ca3f4ae7ca52633c69ca416a50"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a550ec055c2f4e3501aa6abf96e143346"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a550ec055c2f4e3501aa6abf96e143346">fwFSMConfDB_updateDeviceList</a> (string sDomain, string sConfigurator)</td></tr>
<tr class="separator:a550ec055c2f4e3501aa6abf96e143346"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec561c9600b6b41f9153296867cab8e7"><td class="memItemLeft" align="right" valign="top">dyn_string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#aec561c9600b6b41f9153296867cab8e7">fwFSMConfDB_getDomainDevices</a> (string sDomain)</td></tr>
<tr class="separator:aec561c9600b6b41f9153296867cab8e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a32e03919894b5181aa07f08a2dc635"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a0a32e03919894b5181aa07f08a2dc635">fwFSMConfDB_getAllDevices</a> (string domain, string lunit, dyn_string &amp;devices, int ignore_disabled=0, bool excludeMajority=true)</td></tr>
<tr class="separator:a0a32e03919894b5181aa07f08a2dc635"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a506080df4d4fb86849a2112b87b874b3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a506080df4d4fb86849a2112b87b874b3">fwFSMConfDB_isConfigurator</a> (string sDevice)</td></tr>
<tr class="separator:a506080df4d4fb86849a2112b87b874b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afef1dac9b5e3fb7f6f51b23cacfc4ded"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#afef1dac9b5e3fb7f6f51b23cacfc4ded">fwFSMConfDB_getDomainConfigurator</a> (string sDomain)</td></tr>
<tr class="separator:afef1dac9b5e3fb7f6f51b23cacfc4ded"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3819805f2487da41ae1de1cb720606d8"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a3819805f2487da41ae1de1cb720606d8">fwFSMConfDB_removeSystemName</a> (string sDpName)</td></tr>
<tr class="separator:a3819805f2487da41ae1de1cb720606d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64b5af48fbe3cef1c6b09cab461ac7a5"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a64b5af48fbe3cef1c6b09cab461ac7a5">fwFSMConfDB_waitForStateChange</a> (string sDomain, string sConfigurator, time timeout)</td></tr>
<tr class="separator:a64b5af48fbe3cef1c6b09cab461ac7a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a824fcb0336c03f9fe5c450acb6da031d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a824fcb0336c03f9fe5c450acb6da031d">fwFSMConfDB_initConfDBConnection</a> ()</td></tr>
<tr class="separator:a824fcb0336c03f9fe5c450acb6da031d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a73f427aab1f1b6fe471f6cdc60535159"><td class="memItemLeft" align="right" valign="top">dyn_string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a73f427aab1f1b6fe471f6cdc60535159">fwFSMConfDB_getConfiguratorDevices</a> (string sConfigurator)</td></tr>
<tr class="separator:a73f427aab1f1b6fe471f6cdc60535159"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a48dd4091e7f7f3b262ac8ded0349e869"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a48dd4091e7f7f3b262ac8ded0349e869">fwFSMConfDB_cacheExists</a> (string sCache)</td></tr>
<tr class="separator:a48dd4091e7f7f3b262ac8ded0349e869"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f34a1a3fccbb21e33d8c64bcc2604a3"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a2f34a1a3fccbb21e33d8c64bcc2604a3">fwFSMConfDB_cacheAllRecipesForMode</a> (string sDomain, string sMode=&quot;&quot;)</td></tr>
<tr class="separator:a2f34a1a3fccbb21e33d8c64bcc2604a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2d5fd873977bcb92ae8f46a6f7f91a5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#aa2d5fd873977bcb92ae8f46a6f7f91a5">fwFSMConfDB_setState</a> (string sDevice, string sState)</td></tr>
<tr class="separator:aa2d5fd873977bcb92ae8f46a6f7f91a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2c7ff10f95797f07a5063b8f34bfc43"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#ae2c7ff10f95797f07a5063b8f34bfc43">fwFSMConfDB_setCurrentMode</a> (string sConfigurator, string sMode)</td></tr>
<tr class="separator:ae2c7ff10f95797f07a5063b8f34bfc43"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c06ef13f120001321f5a40e126db1f4"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a9c06ef13f120001321f5a40e126db1f4">fwFSMConfDB_getCurrentMode</a> (string sConfigurator)</td></tr>
<tr class="separator:a9c06ef13f120001321f5a40e126db1f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2714bd7a1af8d463d45c6dcaa5704d92"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a2714bd7a1af8d463d45c6dcaa5704d92">fwFSMConfDB_applyRecipe</a> (string sDomain, string sDevice, string sCommand, string sMode=&quot;&quot;)</td></tr>
<tr class="separator:a2714bd7a1af8d463d45c6dcaa5704d92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3c3bea2719d955936510294ef4f3a3bb"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a3c3bea2719d955936510294ef4f3a3bb">fwFSMConfDB_ApplyRecipe</a> (string sDomain, string sDevice, string sCommand, string sMode=&quot;&quot;)</td></tr>
<tr class="separator:a3c3bea2719d955936510294ef4f3a3bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a629136064d98cd15bdfc86746d2dc48c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a629136064d98cd15bdfc86746d2dc48c">fwFSMConfDB_applyUserRecipe</a> (string recipeName, dyn_string devices=&quot;&quot;)</td></tr>
<tr class="separator:a629136064d98cd15bdfc86746d2dc48c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a39bc6082ca7b04ab4e49e71336bc0384"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a39bc6082ca7b04ab4e49e71336bc0384">fwFSMConfDB_getAllTreeCUs</a> (string fsmTree, dyn_string &amp;CUlist)</td></tr>
<tr class="separator:a39bc6082ca7b04ab4e49e71336bc0384"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d22bdc19a38744335c0c60789934f17"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a7d22bdc19a38744335c0c60789934f17">fwFSMConfDB_getConfiguratorName</a> (string sDomain)</td></tr>
<tr class="separator:a7d22bdc19a38744335c0c60789934f17"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad8a20576300ad6051fb5747645207510"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#ad8a20576300ad6051fb5747645207510">fwFSMConfDB_addConfigurator</a> (string sDomain, string type=&quot;&quot;)</td></tr>
<tr class="separator:ad8a20576300ad6051fb5747645207510"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a889a29656d01ad56bb7da31bfe4cd012"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a889a29656d01ad56bb7da31bfe4cd012">fwFSMConfDB_removeConfigurator</a> (string sDomain, string sConfigurator)</td></tr>
<tr class="separator:a889a29656d01ad56bb7da31bfe4cd012"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b1567af56205c70da57214fb93f8394"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a2b1567af56205c70da57214fb93f8394">fwFSMConfDB_getApplyRecipeUsingConfigurator</a> (string sDomain)</td></tr>
<tr class="separator:a2b1567af56205c70da57214fb93f8394"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1692aed3d074f93d6fcc9b0e3ecd6b36"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a1692aed3d074f93d6fcc9b0e3ecd6b36">fwFSMConfDB_waitForDevices</a> (string sDomain, string sConfigurator)</td></tr>
<tr class="separator:a1692aed3d074f93d6fcc9b0e3ecd6b36"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00eafac3b8e64188600f69282f6b211e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a00eafac3b8e64188600f69282f6b211e">fwFSMConfDB_applyAllRecipesFromCache</a> (string sDomain, string sConfigurator, string sMode=&quot;&quot;)</td></tr>
<tr class="separator:a00eafac3b8e64188600f69282f6b211e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae4d062ac14cdc19453c106c55090531"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#aae4d062ac14cdc19453c106c55090531">fwFSMConfDB_applyRecipeFromCache</a> (string sDomain, string sDevice, string sCommand, string sMode=&quot;&quot;)</td></tr>
<tr class="separator:aae4d062ac14cdc19453c106c55090531"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab955453aadeaa2fd655cdd67b4d7efe2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#ab955453aadeaa2fd655cdd67b4d7efe2">fwFSMConfDB_ApplyRecipeFromCache</a> (string sDomain, string sDevice, string sCommand, string sMode=&quot;&quot;)</td></tr>
<tr class="separator:ab955453aadeaa2fd655cdd67b4d7efe2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a371bce1dbafa2154fe99c52bc5a013a4"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a371bce1dbafa2154fe99c52bc5a013a4">fwFSMConfDB_findDeviceNumber</a> (string sDomain, string sDevice)</td></tr>
<tr class="separator:a371bce1dbafa2154fe99c52bc5a013a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3232843e0db50954b98cdf3bfe010acd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a3232843e0db50954b98cdf3bfe010acd">fwFSMConfDB_requestApplyRecipes</a> (string sDomain, string sDevice, string sCommand, string sMode=&quot;&quot;)</td></tr>
<tr class="separator:a3232843e0db50954b98cdf3bfe010acd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae113c10f42676b70321461ddac299f8a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#ae113c10f42676b70321461ddac299f8a">fwFSMConfDB_getCache</a> (string sDomain, string sDevice, string sCommand, string sMode, string &amp;sCache)</td></tr>
<tr class="separator:ae113c10f42676b70321461ddac299f8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d242df8d68761e6b86a24ce11da169f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a7d242df8d68761e6b86a24ce11da169f">fwFSMConfDB_combineRecipes</a> (dyn_dyn_mixed &amp;dstRecipeObject, dyn_dyn_mixed srcRecipeObject1, dyn_dyn_mixed srcRecipeObject2, dyn_string &amp;exceptionInfo, string mergeMode=&quot;&quot;)</td></tr>
<tr class="separator:a7d242df8d68761e6b86a24ce11da169f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr><td colspan="2"><div class="groupHeader">FSM-ConfDB Interface: Definition of constants</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p>The following constants are used by the FSM - ConfDB Interface </p>
</div></td></tr>
<tr class="memitem:a831bc5241c9e64667317d30859d72738"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a831bc5241c9e64667317d30859d72738"></a>
global string&#160;</td><td class="memItemRight" valign="bottom"><b>fwFSMConfDB_gConfigurationName</b> = &quot;FsmConfDB&quot;</td></tr>
<tr class="separator:a831bc5241c9e64667317d30859d72738"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06c00f47cfa790663811a49b6745ebd7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a06c00f47cfa790663811a49b6745ebd7"></a>
global string&#160;</td><td class="memItemRight" valign="bottom"><b>fwFSMConfDB_gConfigurationDescription</b> = &quot;FSM-ConDB Device Configuration&quot;</td></tr>
<tr class="separator:a06c00f47cfa790663811a49b6745ebd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd577e43bbd9e39b49d61096b9177729"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abd577e43bbd9e39b49d61096b9177729"></a>
global string&#160;</td><td class="memItemRight" valign="bottom"><b>fwFSMConfDB_defaultRecipeMergeMode</b> =&quot;DEVICE&quot;</td></tr>
<tr class="separator:abd577e43bbd9e39b49d61096b9177729"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a271a8c75b5d701d59d0f8645e16f3eee"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a271a8c75b5d701d59d0f8645e16f3eee">g_csErrorState</a> = &quot;ERROR&quot;</td></tr>
<tr class="separator:a271a8c75b5d701d59d0f8645e16f3eee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad318d52ba82607f8d192102bcc778ef9"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#ad318d52ba82607f8d192102bcc778ef9">g_csReadyState</a> = &quot;READY&quot;</td></tr>
<tr class="separator:ad318d52ba82607f8d192102bcc778ef9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7500ff773de10107777832afea1d12c"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#ae7500ff773de10107777832afea1d12c">g_csNotReadyState</a> = &quot;NOT_READY&quot;</td></tr>
<tr class="separator:ae7500ff773de10107777832afea1d12c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16be6af2f0284dc7f1844af50ca33ae5"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a16be6af2f0284dc7f1844af50ca33ae5">fwFSMConfDB_OK</a> = 0</td></tr>
<tr class="separator:a16be6af2f0284dc7f1844af50ca33ae5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2468817db044cf8e0baca5e75aace2cf"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#a2468817db044cf8e0baca5e75aace2cf">fwFSMConfDB_ERROR</a> = -1</td></tr>
<tr class="separator:a2468817db044cf8e0baca5e75aace2cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2fc06064597c1e772f07a0e3ce884030"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2fc06064597c1e772f07a0e3ce884030"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csFSMConfDBDPT</b> = &quot;FwFSMConfDB&quot;</td></tr>
<tr class="separator:a2fc06064597c1e772f07a0e3ce884030"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb3390c0be8bc9d38c5223a4a03018af"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adb3390c0be8bc9d38c5223a4a03018af"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csFwFSMConfDBDelimiter</b> = &quot;/&quot;</td></tr>
<tr class="separator:adb3390c0be8bc9d38c5223a4a03018af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a96eae29db2a235aef84f351268ff2d0d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a96eae29db2a235aef84f351268ff2d0d"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csFwFSMConfDBSetup</b> = &quot;FwFSMConfDB&quot;</td></tr>
<tr class="separator:a96eae29db2a235aef84f351268ff2d0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a503dd728a539c0659b33b4a4f7cf974d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a503dd728a539c0659b33b4a4f7cf974d"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csModeDelimiter</b> = &quot;|&quot;</td></tr>
<tr class="separator:a503dd728a539c0659b33b4a4f7cf974d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a805b0bfcf117a126bcbc561761809852"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a805b0bfcf117a126bcbc561761809852"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csDevicesDPE</b> = &quot;.devices&quot;</td></tr>
<tr class="separator:a805b0bfcf117a126bcbc561761809852"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee613ef7afc97b54637306a53c983c98"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aee613ef7afc97b54637306a53c983c98"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csCommandsDPE</b> = &quot;.commands&quot;</td></tr>
<tr class="separator:aee613ef7afc97b54637306a53c983c98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9950280a017d2ecd503203e6b3568047"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9950280a017d2ecd503203e6b3568047"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csCachesDPE</b> = &quot;.caches&quot;</td></tr>
<tr class="separator:a9950280a017d2ecd503203e6b3568047"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afada0515e0cc5438276dfd624aafd848"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afada0515e0cc5438276dfd624aafd848"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csRecipesDPE</b> = &quot;.recipes&quot;</td></tr>
<tr class="separator:afada0515e0cc5438276dfd624aafd848"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a000b5dafb1293e2e37e6874485ca124b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a000b5dafb1293e2e37e6874485ca124b"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csUseConfDBDPE</b> = &quot;.useConfDB&quot;</td></tr>
<tr class="separator:a000b5dafb1293e2e37e6874485ca124b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64685fda223a769e6f90fcf5b822328e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a64685fda223a769e6f90fcf5b822328e"></a>
const int&#160;</td><td class="memItemRight" valign="bottom"><b>g_maxCmdNr</b> = 10</td></tr>
<tr class="separator:a64685fda223a769e6f90fcf5b822328e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a597534137095e4a0161a10c4ad208ab9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a597534137095e4a0161a10c4ad208ab9"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_CachePrefix</b> = &quot;FwFSMConfDB&quot;</td></tr>
<tr class="separator:a597534137095e4a0161a10c4ad208ab9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7fa1723c7916ba4c9e0c7c96074ea68"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad7fa1723c7916ba4c9e0c7c96074ea68"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csSplitAtDpe</b> = &quot;FwFSMConfDBParametrization.splitCachesAt&quot;</td></tr>
<tr class="separator:ad7fa1723c7916ba4c9e0c7c96074ea68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0444b93827328bd261b5c0c55f516b5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac0444b93827328bd261b5c0c55f516b5"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csForceUpdate</b> = &quot;FwFSMConfDBParametrization.forceUpdateFromDB&quot;</td></tr>
<tr class="separator:ac0444b93827328bd261b5c0c55f516b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ecee96f83bc0ea601cdb735b47eeeae"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8ecee96f83bc0ea601cdb735b47eeeae"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csStopOnError</b> = &quot;FwFSMConfDBParametrization.stopOnError&quot;</td></tr>
<tr class="separator:a8ecee96f83bc0ea601cdb735b47eeeae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86cd9ed13365f841e186ae6e2e37f066"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a86cd9ed13365f841e186ae6e2e37f066"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csStopNoRecipes</b> = &quot;FwFSMConfDBParametrization.stopNoRecipes&quot;</td></tr>
<tr class="separator:a86cd9ed13365f841e186ae6e2e37f066"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c276227b55af4024562cfef7707c221"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4c276227b55af4024562cfef7707c221"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csClearCaches</b> = &quot;FwFSMConfDBParametrization.clearCaches&quot;</td></tr>
<tr class="separator:a4c276227b55af4024562cfef7707c221"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8d1069b0187f0b2b9aa480a533f1286"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae8d1069b0187f0b2b9aa480a533f1286"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csDUTypesDPE</b> = &quot;.duTypes&quot;</td></tr>
<tr class="separator:ae8d1069b0187f0b2b9aa480a533f1286"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2a513d88fbd76540561006e5a3374e0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad2a513d88fbd76540561006e5a3374e0"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csConfiguratorDUType</b> = &quot;FwFSMConfDBDUT&quot;</td></tr>
<tr class="separator:ad2a513d88fbd76540561006e5a3374e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a8d4f750989af39f41372b631e10090"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5a8d4f750989af39f41372b631e10090"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csDelayInterval</b> = &quot;FwFSMConfDBParametrization.delayInterval&quot;</td></tr>
<tr class="separator:a5a8d4f750989af39f41372b631e10090"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a569046e8609721c97b82df32a2f32ce0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a569046e8609721c97b82df32a2f32ce0"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csApplyRecipesTimeout</b> = &quot;.applyRecipes.timeout&quot;</td></tr>
<tr class="separator:a569046e8609721c97b82df32a2f32ce0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5726b48d2e7f15cb540ea80a62f6098"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac5726b48d2e7f15cb540ea80a62f6098"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csApplyRecipeUsingConfigurator</b> = &quot;.applyRecipes.usingConfigurator&quot;</td></tr>
<tr class="separator:ac5726b48d2e7f15cb540ea80a62f6098"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e90aa37359289074b6a8faa764ce8a3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6e90aa37359289074b6a8faa764ce8a3"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csApplyRecipeSimplified</b> = &quot;.applyRecipes.simplifiedAR&quot;</td></tr>
<tr class="separator:a6e90aa37359289074b6a8faa764ce8a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9e6000cefa225cc32f14ab675bd2eaa"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae9e6000cefa225cc32f14ab675bd2eaa"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csRecipePattern</b> = &quot;.recipePattern&quot;</td></tr>
<tr class="separator:ae9e6000cefa225cc32f14ab675bd2eaa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a98ec9e1d07afefcbc668dcda611eeb"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7a98ec9e1d07afefcbc668dcda611eeb"></a>
const string&#160;</td><td class="memItemRight" valign="bottom"><b>g_csIgnoreDeviceList</b> = &quot;.ignoreDeviceList&quot;</td></tr>
<tr class="separator:a7a98ec9e1d07afefcbc668dcda611eeb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">FSM-ConfDB Interface: Definition of variables</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p>The following variables are used by the FSM - ConfDB Interface </p>
</div></td></tr>
<tr class="memitem:abf5b93689e8f9fad9a81091356d12e03"><td class="memItemLeft" align="right" valign="top">global string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwFsmConfDB_8ctl.html#abf5b93689e8f9fad9a81091356d12e03">g_sFwDevice_HIERARCHY</a></td></tr>
<tr class="separator:abf5b93689e8f9fad9a81091356d12e03"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This package contains the functions used by the interface between the Finite State Machine and the Configuration DB.</p>
<dl class="section author"><dt>Author</dt><dd>Francisca Calheiros(IT-CO/BE) and Fernando Varela (IT-CO/BE) </dd></dl>
<dl class="section date"><dt>Date</dt><dd>29th of July 2008 </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="aec2ab037a47918414e6efd114b2ad62b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_initialize </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initializes the FSMConfDB configurator. In addition, it also initializes the connection to the Configuration DB and the internal list of devices to be configured in the SMI++ domain. If connection to ConfDB cannot be established, the configurator goes to an ERROR state, otherwise to NOT_READY state. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>Name of the SMI++ domain </td></tr>
    <tr><td class="paramname">sConfigurator</td><td>name of the configurator </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 if error, 0 if OK </dd></dl>

</div>
</div>
<a class="anchor" id="a425183ca3f4ae7ca52633c69ca416a50"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwFSMConfDB_getUseConfDB </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the UseConfDB flag </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sConfigurator</td><td>name of the configurator </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TRUE if ConfDB is in use, otherwise FALSE </dd></dl>

</div>
</div>
<a class="anchor" id="a550ec055c2f4e3501aa6abf96e143346"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwFSMConfDB_updateDeviceList </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Updates the internal list of devices handled by a FSMConfDB configurator </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>Name of the SMI++ domain as a string </td></tr>
    <tr><td class="paramname">sConfigurator</td><td>name of the domain configurator </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aec561c9600b6b41f9153296867cab8e7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dyn_string fwFSMConfDB_getDomainDevices </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Retrives the list of devices to be handle by a FSMConfDB configurator </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>Name of the SMI++ domain as a string </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>list of devices in the SMI++ domain </dd></dl>

</div>
</div>
<a class="anchor" id="a0a32e03919894b5181aa07f08a2dc635"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwFSMConfDB_getAllDevices </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>domain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>lunit</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>devices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ignore_disabled</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>excludeMajority</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets all Device Units in a SMI++ domain recursively </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">domain</td><td>Name of the SMI++ domain as a string </td></tr>
    <tr><td class="paramname">lunit</td><td>logical unit </td></tr>
    <tr><td class="paramname">devices</td><td>list of devices as a dyn_string </td></tr>
    <tr><td class="paramname">ignore_disabled</td><td>optional flag to indicate whether the disabled devices must be included in the list or not. The default value is 0 </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a506080df4d4fb86849a2112b87b874b3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwFSMConfDB_isConfigurator </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to check whether a device is a configurator or not </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDevice</td><td>name of the device to be checked </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>TRUE if the device is a configurator otherwise FALSE </dd></dl>

</div>
</div>
<a class="anchor" id="afef1dac9b5e3fb7f6f51b23cacfc4ded"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string fwFSMConfDB_getDomainConfigurator </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Retrieves the name of the configurator object in an SMI++ domain </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>name of the FSMConfDB configurator </dd></dl>

</div>
</div>
<a class="anchor" id="a3819805f2487da41ae1de1cb720606d8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string fwFSMConfDB_removeSystemName </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDpName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Removes the system name from a dp-name </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDpName</td><td>name of the dp </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>dp-name without the system name </dd></dl>

</div>
</div>
<a class="anchor" id="a64b5af48fbe3cef1c6b09cab461ac7a5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwFSMConfDB_waitForStateChange </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>timeout</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This function connects to the state of the FSMConfDB configurator. Should the state of the configurator is set to READY after the time given by the timeout value the function returns TRUE, otherwise FALSE. This function is intended to be called from the DU in the hierarchy to pause their transitions while the configurator object loads all recipes from the ConfDB. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>Name of the SMI++ object </td></tr>
    <tr><td class="paramname">sConfigurator</td><td>Name of the FSMConfDB Configurator </td></tr>
    <tr><td class="paramname">timeout</td><td>time interval to wait before the state of the configurator is set to ERROR </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>flag indicating if the action has timed out or not. </dd></dl>

</div>
</div>
<a class="anchor" id="a824fcb0336c03f9fe5c450acb6da031d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_initConfDBConnection </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initializes the connection to the ConfDB for a given setup </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">setupName</td><td>name of the setup in the configuration DB </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 if error, 0 if OK </dd></dl>

</div>
</div>
<a class="anchor" id="a73f427aab1f1b6fe471f6cdc60535159"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">dyn_string fwFSMConfDB_getConfiguratorDevices </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the list of device units to be configured by a FSMConfDB configurator </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sConfigurator</td><td>name of the configurator </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>list of devices units </dd></dl>

</div>
</div>
<a class="anchor" id="a48dd4091e7f7f3b262ac8ded0349e869"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_cacheExists </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sCache</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Checks if a recipe cache exists </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sCache</td><td>recipe cache name </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 if it does not exist or 0 if all OK </dd></dl>

</div>
</div>
<a class="anchor" id="a2f34a1a3fccbb21e33d8c64bcc2604a3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_cacheAllRecipesForMode </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Synchronizes the contents (i.e. recipes) of the configuration DB and the internal PVSS caches used by the Configuration DB tool, for a given running mode of the experiment. This function also sets up the internal data-points which hold the so-called "Recipe Dictionary". The recipe dictionary is an internal table which holds the cache names for the different devices and recipes in a SMI++ control domain. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ control domain </td></tr>
    <tr><td class="paramname">sMode</td><td>running mode of the experiment to load the recipes for. This is an optional parameter. If left empty, the current running mode of the experiment is resolved by the FWFSMConfDB Interface </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 if OK </dd></dl>

</div>
</div>
<a class="anchor" id="aa2d5fd873977bcb92ae8f46a6f7f91a5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_setState </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sState</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the state of the FSMConfDB Configurator </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDevice</td><td>name of the device to set the device to </td></tr>
    <tr><td class="paramname">sState</td><td>desired state </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 if OK </dd></dl>

</div>
</div>
<a class="anchor" id="ae2c7ff10f95797f07a5063b8f34bfc43"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_setCurrentMode </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the running mode to the FSMConfDB Configurator </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sConfigurator</td><td>name of the FSMConfDB configurator </td></tr>
    <tr><td class="paramname">sMode</td><td>experiment's running mode </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 if OK </dd></dl>

</div>
</div>
<a class="anchor" id="a9c06ef13f120001321f5a40e126db1f4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string fwFSMConfDB_getCurrentMode </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the running mode(PHYSICS,COSMICS,...) to the FSMConfDB Configurator </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sConfigurator</td><td>name of the FSMConfDB configurator </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>current running mode </dd></dl>

</div>
</div>
<a class="anchor" id="a2714bd7a1af8d463d45c6dcaa5704d92"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_applyRecipe </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sCommand</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Applies a recipe cache associated to a FSM command to a device </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">sDevice</td><td>name of the device to apply the recipe to </td></tr>
    <tr><td class="paramname">sCommand</td><td>SMI++ command </td></tr>
    <tr><td class="paramname">sMode</td><td>running mode. This parameter is optional. If empty, it is current running mode resolved by the function </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a3c3bea2719d955936510294ef4f3a3bb"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_ApplyRecipe </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sCommand</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Applies a recipe cache associated to a FSM command to a device </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">sDevice</td><td>name of the device to apply the recipe to </td></tr>
    <tr><td class="paramname">sCommand</td><td>SMI++ command </td></tr>
    <tr><td class="paramname">sMode</td><td>running mode. This parameter is optional. If empty, it is current running mode resolved by the function </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 otherwise </dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000001">Deprecated:</a></b></dt><dd>use <a class="el" href="fwFsmConfDB_8ctl.html#a2714bd7a1af8d463d45c6dcaa5704d92">fwFSMConfDB_applyRecipe</a> instead </dd></dl>

</div>
</div>
<a class="anchor" id="a629136064d98cd15bdfc86746d2dc48c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_applyUserRecipe </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>devices</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Applies a user recipe cache associated to a device or group of devices </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">devices</td><td>list of devices to apply the recipe to </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a39bc6082ca7b04ab4e49e71336bc0384"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_getAllTreeCUs </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>fsmTree</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>CUlist</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get all CU's belonging to a Tree. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">fsmTree</td><td>name of the Tree </td></tr>
    <tr><td class="paramname">CUlist</td><td>list of CUs in the tree </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7d22bdc19a38744335c0c60789934f17"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string fwFSMConfDB_getConfiguratorName </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The function returns the name of the configurator to an SMI++ domain </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>name of the configurator. </dd></dl>

</div>
</div>
<a class="anchor" id="ad8a20576300ad6051fb5747645207510"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_addConfigurator </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>type</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The function adds a configurator to a SMI++ domain. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">type</td><td>configurator DU type </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code: 0 if all OK, -1 if error. </dd></dl>

</div>
</div>
<a class="anchor" id="a889a29656d01ad56bb7da31bfe4cd012"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_removeConfigurator </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Removes a configurator of an SMI++ domain. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">sConfigurator</td><td>name of the configurator </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Error code: 0 if all OK, -1 if error. </dd></dl>

</div>
</div>
<a class="anchor" id="a2b1567af56205c70da57214fb93f8394"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_getApplyRecipeUsingConfigurator </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the flag value that indicates the mode to be used to apply recipes </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sConfigurator</td><td>name of the configurator </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1: configurator applies recipes to all enabled devices in its CU, 2: configurator applies the same recipe to all anabled devices(simplified APPLY_RECIPE) 0: device apply recipe to itself </dd></dl>

</div>
</div>
<a class="anchor" id="a1692aed3d074f93d6fcc9b0e3ecd6b36"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_waitForDevices </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Waits for the requests of all the enabled devices that are executing an action </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">sConfigurator</td><td>name of the configurator </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a00eafac3b8e64188600f69282f6b211e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_applyAllRecipesFromCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sConfigurator</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Fuction used by the configurator to apply the recipes to all enabled devices in a CU </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">sConfigurator</td><td>name of the configurator </td></tr>
    <tr><td class="paramname">sMode</td><td>running mode. This parameter is optional. If empty, it is current running mode resolved by the function </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="aae4d062ac14cdc19453c106c55090531"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_applyRecipeFromCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sCommand</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Checks if it's either the configurator or the device to apply the recipe and calls respectively the function <a class="el" href="fwFsmConfDB_8ctl.html#a3232843e0db50954b98cdf3bfe010acd">fwFSMConfDB_requestApplyRecipes()</a>or <a class="el" href="fwFsmConfDB_8ctl.html#a2714bd7a1af8d463d45c6dcaa5704d92">fwFSMConfDB_applyRecipe()</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">sDevice</td><td>name of the device to apply the recipe to </td></tr>
    <tr><td class="paramname">sCommand</td><td>SMI++ command </td></tr>
    <tr><td class="paramname">sMode</td><td>running mode. This parameter is optional. If empty, it is current running mode </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="ab955453aadeaa2fd655cdd67b4d7efe2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_ApplyRecipeFromCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sCommand</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Checks if it's either the configurator or the device to apply the recipe and calls respectively the function <a class="el" href="fwFsmConfDB_8ctl.html#a3232843e0db50954b98cdf3bfe010acd">fwFSMConfDB_requestApplyRecipes()</a>or <a class="el" href="fwFsmConfDB_8ctl.html#a3c3bea2719d955936510294ef4f3a3bb">fwFSMConfDB_ApplyRecipe()</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ domain </td></tr>
    <tr><td class="paramname">sDevice</td><td>name of the device to apply the recipe to </td></tr>
    <tr><td class="paramname">sCommand</td><td>SMI++ command </td></tr>
    <tr><td class="paramname">sMode</td><td>running mode. This parameter is optional. If empty, it is current running mode </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 otherwise </dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000002">Deprecated:</a></b></dt><dd>use <a class="el" href="fwFsmConfDB_8ctl.html#aae4d062ac14cdc19453c106c55090531">fwFSMConfDB_applyRecipeFromCache</a> instead </dd></dl>

</div>
</div>
<a class="anchor" id="a371bce1dbafa2154fe99c52bc5a013a4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_findDeviceNumber </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Finds the index number of the sDevice in the list of devices handle by a FSMConfDB configurator </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>Name of the SMI++ domain as a string </td></tr>
    <tr><td class="paramname">sDevice</td><td>name of the SMI++ device </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the index of the device, 0 if device doesn't exist in the list </dd></dl>

</div>
</div>
<a class="anchor" id="a3232843e0db50954b98cdf3bfe010acd"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_requestApplyRecipes </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sCommand</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Request configurator to apply recipe(populate configurator's variables)if command comes from a parent, otherwise apply recipe to current device </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>Name of the SMI++ domain as a string </td></tr>
    <tr><td class="paramname">sDevice</td><td>name of the SMI++ device </td></tr>
    <tr><td class="paramname">sCommand</td><td>SMI++ command </td></tr>
    <tr><td class="paramname">sMode</td><td>running mode. This parameter is optional. If empty, it is current running mode resolved by the function </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="ae113c10f42676b70321461ddac299f8a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwFSMConfDB_getCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDomain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sCommand</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sMode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>sCache</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Retrieves the cache name where the configuration information is stored for a given mode and command in a SMI++ domain </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">sDomain</td><td>name of the SMI++ control domain </td></tr>
    <tr><td class="paramname">sDevice</td><td>name of the device to be configured </td></tr>
    <tr><td class="paramname">sCommand</td><td>name of the command associated with the cache </td></tr>
    <tr><td class="paramname">sMode</td><td>running mode of the experiment to load the recipes for </td></tr>
    <tr><td class="paramname">sCache</td><td>name of the cache holding the configuration information </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>error code: -1 in the event of error, 0 if OK </dd></dl>

</div>
</div>
<a class="anchor" id="a7d242df8d68761e6b86a24ce11da169f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwFSMConfDB_combineRecipes </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>dstRecipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>srcRecipeObject1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>srcRecipeObject2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>mergeMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>combines two recipe objects This function combines two recipe object into third object. For the entries that exist in both source recipes, the one in the second recipe have precedence, and will be used.</p>
<p>The meta-information is treated in the following way: if there is no meta information yet in the first recipe, the meta information from <em>srcRecipeObject2</em> is taken; otherwise, if there is already a meta-information in the <em>srcRecipeObject1</em>, it is discarded except the recipe type name - this one will be set in the <em>dstRecipeObject</em> if it is set in both srcRecipeObjects to equal values.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dstRecipeObject</td><td>on return will contain the combined recipe </td></tr>
    <tr><td class="paramname">srcRecipeObject1</td><td>first recipe to combine </td></tr>
    <tr><td class="paramname">srcRecipeObject2</td><td>second recipe to combine </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">mergeMode</td><td>(optional, default="") determines the mode in which the merge is performed; "DEVICE" - the mode is per device "ELEMENT" - the mode is per element "" - take the global setting</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See Also</dt><dd>qstart_recipes section of Quick Start </dd></dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a class="anchor" id="a271a8c75b5d701d59d0f8645e16f3eee"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const string g_csErrorState = &quot;ERROR&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Name of the ERROR state of the configurator </p>

</div>
</div>
<a class="anchor" id="ad318d52ba82607f8d192102bcc778ef9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const string g_csReadyState = &quot;READY&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Name of the READY state of the configurator </p>

</div>
</div>
<a class="anchor" id="ae7500ff773de10107777832afea1d12c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const string g_csNotReadyState = &quot;NOT_READY&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Name of the NOT_READY state of the configurator </p>

</div>
</div>
<a class="anchor" id="a16be6af2f0284dc7f1844af50ca33ae5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwFSMConfDB_OK = 0</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>FSMConfDB return OK </p>

</div>
</div>
<a class="anchor" id="a2468817db044cf8e0baca5e75aace2cf"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwFSMConfDB_ERROR = -1</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>general FSMCOnfDB error code </p>

</div>
</div>
<a class="anchor" id="abf5b93689e8f9fad9a81091356d12e03"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">global string g_sFwDevice_HIERARCHY</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Name of the FW Hierarchy to be used </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="fwFsmConfDB_8ctl.html">fwFsmConfDB.ctl</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.5 </li>
  </ul>
</div>
</body>
</html>
